$(function() {
var editorInstance = $(".html-editor").dxHtmlEditor({
height: 300,
toolbar: {
items: [
"undo", "redo", "separator",
{
formatName: "size",
formatValues: ["8pt", "10pt", "12pt", "14pt", "18pt", "24pt", "36pt"]
},
{
formatName: "font",
formatValues: ["Arial", "Courier New", "Georgia", "Impact", "Lucida Console", "Tahoma", "Times New Roman", "Verdana"]
},
"separator",
"bold", "italic", "strike", "underline", "separator",
"alignLeft", "alignCenter", "alignRight", "alignJustify", "separator",
"color", "background"
]
},
onValueChanged: function(e) {
$(".value-content").text(e.component.option("value"));
}
}).dxHtmlEditor("instance");
$(".value-types").dxButtonGroup({
items: [{ text: "Html" }, { text: "Markdown" }],
selectedItemKeys: ["Html"],
onSelectionChanged: function(e) {
editorInstance.option("valueType", e.addedItems[0].text.toLowerCase());
$(".value-content").text(editorInstance.option("value"));
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge"/>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0"/>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css"/>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css"/>
<script src="https://unpkg.com/devextreme-quill/dist/dx-quill.min.js"></script>
<script src="https://unpkg.com/turndown/dist/turndown.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/showdown/1.8.7/showdown.min.js"></script>
<script src="https://cdn3.devexpress.com/jslib/20.2.5/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css"/>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="html-editor">
<h2>
<img src="images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme HTML5 JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format
textual and visual content and store it as HTML or Markdown.</p>
</div>
<div class="options">
<div class="value-types"></div>
<div class="value-content"></div>
</div>
</div>
</body>
</html>
.dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
.value-content {
margin-top: 20px;
overflow: auto;
height: 110px;
width: 100%;
white-space: pre-wrap;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
box-sizing: border-box;
width: 100%;
}

<dx-html-editor
[height]="300"
[(valueType)]="editorValueType"
[(value)]="valueContent"
>
<dxo-toolbar>
<dxi-item name="undo"></dxi-item>
<dxi-item name="redo"></dxi-item>
<dxi-item name="separator"></dxi-item>
<dxi-item
name="size"
[acceptedValues]="['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt']"
></dxi-item>
<dxi-item
name="font"
[acceptedValues]="[
'Arial',
'Courier New',
'Georgia',
'Impact',
'Lucida Console',
'Tahoma',
'Times New Roman',
'Verdana'
]"
></dxi-item>
<dxi-item name="separator"></dxi-item>
<dxi-item name="bold"></dxi-item>
<dxi-item name="italic"></dxi-item>
<dxi-item name="strike"></dxi-item>
<dxi-item name="underline"></dxi-item>
<dxi-item name="separator"></dxi-item>
<dxi-item name="alignLeft"></dxi-item>
<dxi-item name="alignCenter"></dxi-item>
<dxi-item name="alignRight"></dxi-item>
<dxi-item name="alignJustify"></dxi-item>
<dxi-item name="separator"></dxi-item>
<dxi-item name="color"></dxi-item>
<dxi-item name="background"></dxi-item>
</dxo-toolbar>
</dx-html-editor>
<div class="options">
<dx-button-group
(onSelectionChanged)="onValueTypeChanged($event)"
[selectedItemKeys]="['Html']"
>
<dxi-item text="Html"></dxi-item>
<dxi-item text="Markdown"></dxi-item>
</dx-button-group>
<div class="value-content">{{ prettierFormat(valueContent) }}</div>
</div>
import {
NgModule, ViewChild, Component, enableProdMode,
} from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import {
DxButtonGroupModule,
DxHtmlEditorModule,
} from 'devextreme-angular';
import 'devextreme/ui/html_editor/converters/markdown';
import prettier from 'prettier/standalone';
import parserHtml from 'prettier/parser-html';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
valueContent: string;
editorValueType = 'html';
constructor(service: Service) {
this.valueContent = service.getMarkup();
}
onValueTypeChanged({ addedItems }) {
this.editorValueType = addedItems[0].text.toLowerCase();
}
prettierFormat(markup: string) {
if (this.editorValueType === 'html') {
return prettier.format(markup, {
parser: 'html',
plugins: [parserHtml],
});
}
return markup;
}
}
@NgModule({
imports: [
BrowserModule,
DxHtmlEditorModule,
DxButtonGroupModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
::ng-deep .value-content {
margin-top: 20px;
overflow: auto;
height: 110px;
width: 100%;
white-space: pre-wrap;
}
::ng-deep .options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
box-sizing: border-box;
width: 100%;
}
import { Injectable } from '@angular/core';
const markup = '<h2><img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor"> Formatted Text Editor (HTML Editor)</h2><p><br></p><p>DevExtreme JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML or Markdown.</p>';
@Injectable()
export class Service {
getMarkup(): string {
return markup;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-showdown': 'npm:devextreme-showdown@1.0.1/dist/showdown.js',
'turndown': 'npm:turndown@7.1.2/lib/turndown.browser.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.3/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37',
'devextreme-angular': 'npm:devextreme-angular@22.2.3',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.3/*/package.json',
'npm:devextreme-angular@22.2.3/ui/*/package.json',
'npm:devextreme-angular@22.2.3/package.json',
'npm:devexpress-diagram@2.1.65/package.json',
'npm:devexpress-gantt@4.1.37/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import { markup } from './data.js';
import HtmlEditor, { Toolbar, Item } from 'devextreme-react/html-editor';
import ButtonGroup, { Item as ButtonItem } from 'devextreme-react/button-group';
import 'devextreme/ui/html_editor/converters/markdown';
const sizeValues = ['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt'];
const fontValues = ['Arial', 'Courier New', 'Georgia', 'Impact', 'Lucida Console', 'Tahoma', 'Times New Roman', 'Verdana'];
class App extends React.Component {
constructor() {
super();
this.state = {
valueContent: markup,
editorValueType: 'html'
};
this.valueChanged = this.valueChanged.bind(this);
this.valueTypeChanged = this.valueTypeChanged.bind(this);
}
render() {
let { valueContent, editorValueType } = this.state;
return (
<div className="widget-container">
<HtmlEditor
height={300}
value={valueContent}
valueType={editorValueType}
onValueChanged={this.valueChanged}
>
<Toolbar>
<Item formatName="undo" />
<Item formatName="redo" />
<Item formatName="separator" />
<Item
formatName="size"
formatValues={sizeValues}
/>
<Item
formatName="font"
formatValues={fontValues}
/>
<Item formatName="separator" />
<Item formatName="bold" />
<Item formatName="italic" />
<Item formatName="strike" />
<Item formatName="underline" />
<Item formatName="separator" />
<Item formatName="alignLeft" />
<Item formatName="alignCenter" />
<Item formatName="alignRight" />
<Item formatName="alignJustify" />
<Item formatName="separator" />
<Item formatName="color" />
<Item formatName="background" />
</Toolbar>
</HtmlEditor>
<div className="options">
<ButtonGroup
onSelectionChanged={this.valueTypeChanged}
defaultSelectedItemKeys={['Html']}
>
<ButtonItem text="Html" />
<ButtonItem text="Markdown" />
</ButtonGroup>
<div className="value-content">
{valueContent}
</div>
</div>
</div>
);
}
valueChanged(e) {
this.setState({
valueContent: e.value
});
}
valueTypeChanged(e) {
this.setState({
editorValueType: e.addedItems[0].text.toLowerCase()
});
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
.value-content {
margin-top: 20px;
overflow: auto;
height: 110px;
width: 100%;
white-space: pre-wrap;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
box-sizing: border-box;
width: 100%;
}
export const markup = `
<h2>
<img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML or Markdown.</p>
`;
System.config({
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'showdown': 'npm:showdown@1.9.1/dist/showdown.js',
'turndown': 'npm:turndown@7.0.0/lib/turndown.browser.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.26.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.6',
'devextreme-react': 'npm:devextreme-react@20.2.6',
'jszip': 'npm:jszip@3.6.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.10.3/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.18/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.24/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.13/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.13/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});

<template>
<div class="widget-container">
<dx-html-editor
v-model="valueContent"
:value-type="editorValueType"
:height="300"
>
<dx-toolbar>
<dx-item format-name="undo"/>
<dx-item format-name="redo"/>
<dx-item format-name="separator"/>
<dx-item
:format-values="sizeValues"
format-name="size"
/>
<dx-item
:format-values="fontValues"
format-name="font"
/>
<dx-item format-name="separator"/>
<dx-item format-name="bold"/>
<dx-item format-name="italic"/>
<dx-item format-name="strike"/>
<dx-item format-name="underline"/>
<dx-item format-name="separator"/>
<dx-item format-name="alignLeft"/>
<dx-item format-name="alignCenter"/>
<dx-item format-name="alignRight"/>
<dx-item format-name="alignJustify"/>
<dx-item format-name="separator"/>
<dx-item format-name="color"/>
<dx-item format-name="background"/>
</dx-toolbar>
</dx-html-editor>
<div class="options">
<dx-button-group :selected-items.sync="selectedItems">
<dx-button-group-item text="Html"/>
<dx-button-group-item text="Markdown"/>
</dx-button-group>
<div class="value-content">{{ valueContent }}</div>
</div>
</div>
</template>
<script>
import {
DxHtmlEditor,
DxToolbar,
DxItem
} from 'devextreme-vue/html-editor';
import {
DxButtonGroup,
DxItem as DxButtonGroupItem
} from 'devextreme-vue/button-group';
import { markup } from './data.js';
import 'devextreme/ui/html_editor/converters/markdown';
export default {
components: {
DxHtmlEditor,
DxToolbar,
DxItem,
DxButtonGroup,
DxButtonGroupItem
},
data() {
return {
valueContent: markup,
selectedItems: [{ text: 'Html' }],
sizeValues: ['8pt', '10pt', '12pt', '14pt', '18pt', '24pt', '36pt'],
fontValues: ['Arial', 'Courier New', 'Georgia', 'Impact', 'Lucida Console', 'Tahoma', 'Times New Roman', 'Verdana']
};
},
computed: {
editorValueType: function() {
return this.selectedItems[0].text.toLowerCase();
}
}
};
</script>
<style>
.dx-htmleditor-content img {
vertical-align: middle;
padding-right: 10px;
}
.value-content {
margin-top: 20px;
overflow: auto;
height: 110px;
width: 100%;
white-space: pre-wrap;
}
.options {
margin-top: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
box-sizing: border-box;
width: 100%;
}
</style>
import Vue from 'vue';
import App from './App.vue';
new Vue({
el: '#app',
components: { App },
template: '<App/>'
});
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app">
</div>
</div>
</body>
</html>
export const markup = `
<h2>
<img src="../../../../images/widgets/HtmlEditor.svg" alt="HtmlEditor">
Formatted Text Editor (HTML Editor)
</h2>
<br>
<p>DevExtreme HTML5 JavaScript HTML Editor is a client-side WYSIWYG text editor that allows its users to format textual and visual content and store it as HTML or Markdown.</p>
`;
System.config({
transpiler: 'plugin-babel',
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
vue: 'npm:vue@2.6.3/dist/vue.esm.browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@latest/index.js',
'devextreme': 'npm:devextreme@19.2',
'devextreme-vue': 'npm:devextreme-vue@19.2',
jszip: 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'devexpress-diagram': 'npm:devexpress-diagram',
'devexpress-gantt': 'npm:devexpress-gantt',
'showdown': 'npm:showdown@1.8.6/dist/showdown.js',
'turndown': 'npm:turndown@5.0.1/lib/turndown.browser.umd.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0/plugin-babel.js',
'systemjs-babel-build':
'npm:systemjs-plugin-babel@0/systemjs-babel-browser.js'
},
meta: {
'*.vue': { loader: 'vue-loader' }
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});